<?php
namespace Factory;
use \Zeedhi\DevOps\Model\Projectmanagement\Entities;

class TaskType {


    public function createTaskType($label, $control = null, $project = null, $isIssue = 'N', $isDismissible = 'Y',
                                   $frameOrder = null, $orderToView = null) {
        $entity = new Entities\TaskType();
        $entity->setControl($control);
        $entity->setLabel($label);
        $entity->setProject($project);
        $entity->setIsIssue($isIssue);
        $entity->setAllowCloseIssue($isDismissible);
        $entity->setOrderToFrame($frameOrder);
        $entity->setOrderToView($orderToView);
        return $entity;
    }

    public function saveTaskTypeIssue(Entities\TaskType $entity = null,$control, $label, $allowCloseIssue,
                                   $orderToView = null) {
        if(!$entity){
            $entity = new Entities\TaskType();
        }
        $entity->setLabel($label);
        $entity->setControl($control);
        $entity->setAllowCloseIssue($allowCloseIssue);
        $entity->setOrderToView($orderToView);
        $entity->setIsIssue('Y');
        return $entity;
    }

    /**
     * When you saves a task status, if checked option
     * 'Is initial', saves too INITIAL_TASK_STATUS of
     * TASK_TYPE table.
     * @param Entities\TaskType $entityTaskType
     * @param Entities\TaskStatus $entityTaskStatus
     * @return Entities\TaskType $entityTaskType
     */
    public function updateTaskTypeFromTaskStatus(Entities\TaskType $entityTaskType, Entities\TaskStatus $entityTaskStatus){
        $entityTaskType->setInitialTaskStatus($entityTaskStatus);
        return $entityTaskType;
    }

} 