<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 26/07/2016
 * Time: 11:07
 */

namespace Service;


use Doctrine\ORM\EntityManager;
use Zeedhi\DevOps\Util\Utilities;
use Zeedhi\DevOps\Model\Projectmanagement\Repositories;
use Zeedhi\DevOps\Model\Projectmanagement\Entities;

class ProjectRelationship
{
    /**
     * @var Repositories\ProjectRelationship
     */
    protected $projectRelationshipRepository;

    /**
     * @var EntityManager
     */
    private $entityManager;
    /**
     * @var \Factory\ProjectRelationship
     */
    private $projectRelationshipFactory;
    /**
     * @var \Util\Utilities
     */
    private $environment;

    public function __construct(EntityManager $entityManager, \Util\Utilities $environment,
                                \Factory\ProjectRelationship $projectRelationshipFactory
    )
    {
        $this->entityManager = $entityManager;
        $this->projectRelationshipFactory = $projectRelationshipFactory;
        $this->environment = $environment;
        $this->projectRelationshipRepository = $entityManager->getRepository(Utilities::PROJECT_MANAGEMENT_ENTITY_DIR . 'ProjectRelationship');
    }

    public function createProjectRelationship($project,$projectRelationship,$type) {
        $entity = $this->projectRelationshipFactory->createProjectRelationship($project,$projectRelationship,$type);
        $this->entityManager->persist($entity);
        return $entity;
    }

    public function getOneProjectRelationship($project,$type) {
        $projectRelationship = null;
        /** @var Entities\ProjectRelationship $entity */
        $entity = $this->projectRelationshipRepository->findOneBy(array('project'=>$project,'type' =>$type));
        if($entity){
            $projectRelationship = $entity->getProjectRelationship();
        }
        return $projectRelationship;
    }

    /**
     * @param $projectRelationship
     * @param $type
     * @return Entities\Project[]|array
     */
    public function getProjects($projectRelationship,$type)
    {
        $projects = array();
        /** @var Entities\ProjectRelationship[] $entities */
        $entities = $this->projectRelationshipRepository->findBy(array('projectRelationship' => $projectRelationship, 'type' => $type));
        if (!empty($entities)) {
            foreach ($entities as $entity) {
                $projects[] = $entity->getProject();
            }
        }
        return $projects;
    }
    /**
     * @param $projectRelationship
     * @param $type
     * @return Entities\Project[]|array
     */
    public function hasProject($projectRelationship,$type)
    {
        return !!$this->projectRelationshipRepository->findOneBy(array('projectRelationship' => $projectRelationship, 'type' => $type));
    }
}