/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FUNC                                                     */
/* Tabela : FUNCIONARIO                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_FUNC'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_FUNC
GO

CREATE TRIGGER DTULTATU_FUNC
ON FUNCIONARIO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'FUNCIONARIO', null, 'CDEMPRESA='+ CDEMPRESA + ';'+
                                          'CDFUNC='   + CDFUNC+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE FUNCIONARIO
      SET DTULTATUFUNC = GETDATE()
      FROM INSERTED;
   END;
END;
GO

