<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Entities\Base;


abstract class Project {
    
    
    /** @var \Datetime  */
    protected $beginDate;
    /** @var \Datetime  */
    protected $createdAt;
    /** @var int  */
    protected $createdBy;
    /** @var \Datetime  */
    protected $dateException;
    /** @var string  */
    protected $dateExceptionType;
    /** @var string  */
    protected $description;
    /** @var int  */
    protected $duration;
    /** @var \Datetime  */
    protected $endDate;
    /** @var \Datetime  */
    protected $estimatedDate;
    /** @var int  */
    protected $id;
    /** @var string  */
    protected $inCalc = 'N';
    /** @var string  */
    protected $isIssueProject = 'N';
    /** @var string  */
    protected $name;
    /** @var string  */
    protected $notifyIssueOpening = 'N';
    /** @var int  */
    protected $organization;
    /** @var int  */
    protected $percentCompleted = 0;
    /** @var string  */
    protected $productType = 'I';
    /** @var int  */
    protected $progress;
    /** @var string  */
    protected $status = 'A';
    /** @var string  */
    protected $timePlanned;
    /** @var int  */
    protected $timeRemaining;
    /** @var int  */
    protected $timeSpent;
    /** @var string  */
    protected $treeKey;
    /** @var string  */
    protected $allowReplicationLts = 'N';
    /** @var string  */
    protected $isLtsReplication = 'Y';
    /** @var \Datetime  */
    protected $updatedAt;
    /** @var int  */
    protected $updatedBy;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\Calendar  */
    protected $calendar;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\Classification  */
    protected $classification;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\Project  */
    protected $parent;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskStatus  */
    protected $projectStatus;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\ProjectType  */
    protected $projectType;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\Structure  */
    protected $structure;
    /** @var \Zeedhi\DevOps\Model\Devops\Entities\ProductVersion  */
    protected $productVersion;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\Project[]  */
    protected $subProjects = array (
);
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\Task[]  */
    protected $tasks = array (
);

    public function getBeginDate() {
        return $this->beginDate;
    }
	public function setBeginDate(\Datetime $beginDate = NULL) {
        $this->beginDate = $beginDate;
    }
	public function getCreatedAt() {
        return $this->createdAt;
    }
	public function setCreatedAt(\Datetime $createdAt) {
        $this->createdAt = $createdAt;
    }
	public function getCreatedBy() {
        return $this->createdBy;
    }
	public function setCreatedBy($createdBy = NULL) {
        $this->createdBy = $createdBy;
    }
	public function getDateException() {
        return $this->dateException;
    }
	public function setDateException(\Datetime $dateException = NULL) {
        $this->dateException = $dateException;
    }
	public function getDateExceptionType() {
        return $this->dateExceptionType;
    }
	public function setDateExceptionType($dateExceptionType = NULL) {
        $this->dateExceptionType = $dateExceptionType;
    }
	public function getDescription() {
        return $this->description;
    }
	public function setDescription($description = NULL) {
        $this->description = $description;
    }
	public function getDuration() {
        return $this->duration;
    }
	public function setDuration($duration = NULL) {
        $this->duration = $duration;
    }
	public function getEndDate() {
        return $this->endDate;
    }
	public function setEndDate(\Datetime $endDate = NULL) {
        $this->endDate = $endDate;
    }
	public function getEstimatedDate() {
        return $this->estimatedDate;
    }
	public function setEstimatedDate(\Datetime $estimatedDate = NULL) {
        $this->estimatedDate = $estimatedDate;
    }
	public function getId() {
        return $this->id;
    }
	public function setId($id) {
        $this->id = $id;
    }
	public function getInCalc() {
        return $this->inCalc;
    }
	public function setInCalc($inCalc) {
        $this->inCalc = $inCalc;
    }
	public function getIsIssueProject() {
        return $this->isIssueProject;
    }
	public function setIsIssueProject($isIssueProject = NULL) {
        $this->isIssueProject = $isIssueProject;
    }
	public function getName() {
        return $this->name;
    }
	public function setName($name = NULL) {
        $this->name = $name;
    }
	public function getNotifyIssueOpening() {
        return $this->notifyIssueOpening;
    }
	public function setNotifyIssueOpening($notifyIssueOpening) {
        $this->notifyIssueOpening = $notifyIssueOpening;
    }
	public function getOrganization() {
        return $this->organization;
    }
	public function setOrganization($organization) {
        $this->organization = $organization;
    }
	public function getPercentCompleted() {
        return $this->percentCompleted;
    }
	public function setPercentCompleted($percentCompleted) {
        $this->percentCompleted = $percentCompleted;
    }
	public function getProductType() {
        return $this->productType;
    }
	public function setProductType($productType) {
        $this->productType = $productType;
    }
	public function getProgress() {
        return $this->progress;
    }
	public function setProgress($progress = NULL) {
        $this->progress = $progress;
    }
	public function getStatus() {
        return $this->status;
    }
	public function setStatus($status = NULL) {
        $this->status = $status;
    }
	public function getTimePlanned() {
        return $this->timePlanned;
    }
	public function setTimePlanned($timePlanned = NULL) {
        $this->timePlanned = $timePlanned;
    }
	public function getTimeRemaining() {
        return $this->timeRemaining;
    }
	public function setTimeRemaining($timeRemaining = NULL) {
        $this->timeRemaining = $timeRemaining;
    }
	public function getTimeSpent() {
        return $this->timeSpent;
    }
	public function setTimeSpent($timeSpent = NULL) {
        $this->timeSpent = $timeSpent;
    }
	public function getTreeKey() {
        return $this->treeKey;
    }
	public function setTreeKey($treeKey = NULL) {
        $this->treeKey = $treeKey;
    }
    public function getAllowReplicationLts() {
        return $this->allowReplicationLts;
    }
    public function setAllowReplicationLts($allowReplicationLts = 'N') {
        $this->allowReplicationLts = $allowReplicationLts;
    }
    public function getIsLtsReplication() {
        return $this->isLtsReplication;
    }
    public function setIsLtsReplication($isLtsReplication = 'Y') {
        $this->isLtsReplication = $isLtsReplication;
    }
	public function getUpdatedAt() {
        return $this->updatedAt;
    }
	public function setUpdatedAt(\Datetime $updatedAt) {
        $this->updatedAt = $updatedAt;
    }
	public function getUpdatedBy() {
        return $this->updatedBy;
    }
	public function setUpdatedBy($updatedBy = NULL) {
        $this->updatedBy = $updatedBy;
    }
	public function __construct() {
        $this->createdAt = new \DateTime();
		$this->updatedAt = new \DateTime();
    }
	public function getCalendar() {
        return $this->calendar;
    }
	public function setCalendar(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Calendar $calendar = NULL) {
        $this->calendar = $calendar;
    }
	public function getClassification() {
        return $this->classification;
    }
	public function setClassification(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Classification $classification = NULL) {
        $this->classification = $classification;
    }
	public function getParent() {
        return $this->parent;
    }
	public function setParent(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Project $parent = NULL) {
        $this->parent = $parent;
    }
	public function getProjectStatus() {
        return $this->projectStatus;
    }
	public function setProjectStatus(\Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskStatus $projectStatus = NULL) {
        $this->projectStatus = $projectStatus;
    }
	public function getProjectType() {
        return $this->projectType;
    }
	public function setProjectType(\Zeedhi\DevOps\Model\Projectmanagement\Entities\ProjectType $projectType) {
        $this->projectType = $projectType;
    }
	public function getStructure() {
        return $this->structure;
    }
	public function setStructure(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Structure $structure) {
        $this->structure = $structure;
    }
	public function getSubProjects() {
        return $this->subProjects;
    }
	public function addSubProject(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Project $subProject) {
        $this->subProjects[] = $subProject;
    }
	public function getTasks() {
        return $this->tasks;
    }
	public function addTask(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Task $task) {
        $this->tasks[] = $task;
    }
    public function getProductVersion() {
        return $this->productVersion;
    }
    public function setProductVersion(\Zeedhi\DevOps\Model\Devops\Entities\ProductVersion $productVersion = NULL) {
        $this->productVersion = $productVersion;
    }
}